<?php
//  ---------------------------------------------------------------------------------
//    _____   _             _                   _   _____
//   |  __ \ | |           | |    /\           (_) |  __ \
//   | |__) || |__    __ _ | |   /  \    _ __   _  | |__) |_ __  ___
//   |  ___/ | '_ \  / _` || |  / /\ \  | '_ \ | | |  ___/| '__|/ _ \
//   | |     | | | || (_| || | / ____ \ | |_) || | | |    | |  | (_) |
//   |_|     |_| |_| \__,_||_|/_/    \_\| .__/ |_| |_|    |_|   \___/
//                                      | |
//                                      |_|
//   PhalApi Pro 专业版
//   广州果创网络科技有限公司
//
//  ---------------------------------------------------------------------------------
//
//   一、协议的许可和权利
//    1. 您可以在完全遵守本协议的基础上，将本软件应用于商业用途；
//    2. 您可以在协议规定的约束和限制范围内修改本产品源代码或界面风格以适应您的要求；
//    3. 您拥有使用本产品中的全部内容资料、商品信息及其他信息的所有权，并独立承担与其内容相关的
//       法律义务；
//    4. 获得商业授权之后，您可以将本软件应用于商业用途，自授权时刻起，在技术支持期限内拥有通过
//       指定的方式获得指定范围内的技术支持服务；
//
//   二、协议的约束和限制
//    1. 未获商业授权之前，禁止将本软件用于商业用途（包括但不限于企业法人经营的产品、经营性产品
//       以及以盈利为目的或实现盈利产品）；
//    2. 未获商业授权之前，禁止在本产品的整体或在任何部分基础上发展任何派生版本、修改版本或第三
//       方版本用于重新开发；
//    3. 如果您未能遵守本协议的条款，您的授权将被终止，所被许可的权利将被收回并承担相应法律责任；
//
//   三、有限担保和免责声明
//    1. 本软件及所附带的文件是作为不提供任何明确的或隐含的赔偿或担保的形式提供的；
//    2. 用户出于自愿而使用本软件，您必须了解使用本软件的风险，在尚未获得商业授权之前，我们不承
//       诺提供任何形式的技术支持、使用担保，也不承担任何因使用本软件而产生问题的相关责任；
//    3. 广州果创网络科技有限公司不对使用本产品构建的商城中的内容信息承担责任，但在不侵犯用户隐
//       私信息的前提下，保留以任何方式获取用户信息及商品信息的权利；
//
//   有关本产品最终用户授权协议、商业授权与技术服务的详细内容，均由广州果创网络科技有限公司独家
//   提供。广州果创网络科技有限公司拥有在不事先通知的情况下，修改授权协议的权力，修改后的协议对
//   改变之日起的新授权用户生效。电子文本形式的授权协议如同双方书面签署的协议一样，具有完全的和
//   等同的法律效力。您一旦开始修改、安装或使用本产品，即被视为完全理解并接受本协议的各项条款，
//   在享有上述条款授予的权力的同时，受到相关的约束和限制。协议许可范围以外的行为，将直接违反本
//   授权协议并构成侵权，我们有权随时终止授权，责令停止损害，并保留追究相关责任的权力。
//
//  ---------------------------------------------------------------------------------

namespace Platform\Api;

use PhalApi\Exception\BadRequestException;
use Platform\Common\Api;
use Base\Domain\File as FileDomain;
use OSS\OssClient;
use OSS\Core\OssException;

/**
 * 文件模块
 * 
 */
class File extends Api {

    public function getRules() {
        return array(
            'upload' => array(
                'file' => array(
                    'name' => 'file',        // 客户端上传的文件字段
                    'type' => 'file', 
                    'require' => true, 
                    'max' => 10 * 1024 * 1024,        // 最大允许上传10M 
                    //'range' => array('image/jpeg', 'image/png'),  // 允许的文件格式
                    'ext' => 'jpeg,jpg,png', // 允许的文件扩展名 
                    'desc' => '待上传的文件',
                ),
            ),
            'uploadTypeUpload' => array(
                'file' => array(
                    'name' => 'file',        // 客户端上传的文件字段
                    'type' => 'file',
                    'require' => true,
                    'max' => 10 * 1024 * 1024,        // 最大允许上传10M
                    //'range' => array('image/jpeg', 'image/png'),  // 允许的文件格式
                    //'ext' => 'jpeg,jpg,png', // 允许的文件扩展名
                    'desc' => '待上传的文件',
                ),
            ),
            'uploadByBase64' => array(
                'file' => array('name' => 'file', 'require' => true, 'source' => 'post', 'desc' => '上传
文件进行basse64编码后的数据。<font color="red">此参数必须使用POST方式传递，且必须进行base64编码后传递</font>。'),
                'fileName' => array('name' => 'file_name', 'require' => true, 'desc' => '上传的文件名，需要带上文件扩展名。例如：file_name=文档.doc'),
                'fileType' => array('name' => 'file_type', 'default' => '', 'desc' => '上传的文件类型，用于纪录备忘。例如：file_type=doc'),
            ),
        );
    }   

    /**
     * 文件上传
     * @desc 上传文件到服务器本地，并将上传纪录存在数据库。<a href="/upload.html">本地测试地址</a>。默认可上传任何类型的文件，可通过修改接口参数配置限制文件类型。
     * @return url string 成功上传时返回的图片URL，失败时为空字符串
     */
    public function upload() {
        $rs = array('url' => '');

        $tmpName = $this->file['tmp_name'];

        $pathArr = array($this->getUploadFolderPath(), date('Ymd'));
        $path = implode(DIRECTORY_SEPARATOR, $pathArr);
        $name = date('His') . '_' . md5($this->file['name'] . $_SERVER['REQUEST_TIME']);
        $ext = strrchr($this->file['name'], '.');

        $uploadFolder = implode(DIRECTORY_SEPARATOR, array(API_ROOT, 'public', $path));
        if (!is_dir($uploadFolder)) {
            mkdir($uploadFolder, 0777);
        }

        $filePath = $uploadFolder . DIRECTORY_SEPARATOR . $name . $ext;
        if (move_uploaded_file($tmpName, $filePath)) {
            $domain = new FileDomain();
            
            $fileUrl = sprintf('/%s/%s%s', implode('/', $pathArr), $name, $ext);
            $webUrl = $domain->getHost() . $fileUrl;
            
            $ossUrl = $this->tryToUploadFileToOSS($name . $ext, $filePath);
            if ($ossUrl) {
                $webUrl = $ossUrl;
                //unlink($filePath); // 可以移除本地文件，避免冗余
            }

            $fileId  = $domain->addUploadFile($this->file['name'], $this->file['type'], $this->file['size'], $fileUrl, $webUrl);
            
            $rs['url'] = $webUrl;
            $rs['id'] = $fileId;
        }

        return $rs;
    }


    /**
     * 获取上传类型
     * @desc 获取允许上传的文件类型
     */
    public function uploadType(){
        $result = \PhalApi\DI()->config->get('app.file_uplods_config');
        foreach ($result as $k=>&$v){
            $v = explode('.',$v)[1];
        }

        return $result;
    }


    public function uploadTypeUpload(){
        $rs = array('url' => '');

        $tmpName = $this->file['tmp_name'];

        $pathArr = array($this->getUploadFolderPath(), date('Ymd'));
        $path = implode(DIRECTORY_SEPARATOR, $pathArr);
        $name = date('His') . '_' . md5($this->file['name'] . $_SERVER['REQUEST_TIME']);
        $ext = strrchr($this->file['name'], '.');

//        文件类型限定
        if (!in_array($ext, \PhalApi\DI()->config->get('app.file_uplods_config'))){
            throw new BadRequestException('不支持该文件类型上传，或者联系管理员配置');
        }

        $uploadFolder = implode(DIRECTORY_SEPARATOR, array(API_ROOT, 'public', $path));
        if (!is_dir($uploadFolder)) {
            mkdir($uploadFolder, 0777);
        }

        $filePath = $uploadFolder . DIRECTORY_SEPARATOR . $name . $ext;
        if (move_uploaded_file($tmpName, $filePath)) {
            $domain = new FileDomain();

            $fileUrl = sprintf('/%s/%s%s', implode('/', $pathArr), $name, $ext);
            $webUrl = $domain->getHost() . $fileUrl;

            $ossUrl = $this->tryToUploadFileToOSS($name . $ext, $filePath);
            if ($ossUrl) {
                $webUrl = $ossUrl;
                //unlink($filePath); // 可以移除本地文件，避免冗余
            }

            $fileId = $domain->addUploadFile($this->file['name'], $this->file['type'], $this->file['size'], $fileUrl, $webUrl);

            $rs['url'] = $webUrl;
            $rs['id'] = $fileId;
        }

        return $rs;
    }

    /**
     * base64上传文件
     * @desc 通过Base64编码后，上传图片、Word、Excel和PPT，以及PDF、TXT文本、HTML页面、Zip压缩包等文件。
     * @return string url 成功上传时返回的图片URL，失败时为空
     */
    public function uploadByBase64() {
        $rs = array('url' => '');

        $fileName = $this->fileName;
        $nameArr = explode('.', $fileName);
        $type = strtolower(end($nameArr));
        $allowTypes = array('jpeg', 'jpg', 'png', 'bmp', 'gif', 'ico', 'doc', 'docx', 'xls', 'xlsx', 'ppt', 'pptx', 'pdf', 'txt', 'html', 'log', 'key', 'numbers', 'pages', 'zip', 'rar');
        if (!in_array($type, $allowTypes)) {
            throw new BadRequestException(\PhalApi\T("upload file type {filetype} error, currently only support: {supporttype}",
                        array('fileType' => $type, 'supportType' => implode('/', $allowTypes))));
        }

        $temp = tempnam(sys_get_temp_dir(), md5(date('YmdHis') . $fileName));

        $pathArr = array($this->getUploadFolderPath(), date('Ymd'));
        $path = implode(DIRECTORY_SEPARATOR, $pathArr);
        $name = date('His') . '_' . md5($fileName . $_SERVER['REQUEST_TIME']);
        $ext = '.' . $type;

        $uploadFolder = implode(DIRECTORY_SEPARATOR, array(API_ROOT, 'public', $path));
        if (!is_dir($uploadFolder)) {
            mkdir($uploadFolder, 0777);
        }

        $filePath = $uploadFolder . DIRECTORY_SEPARATOR . $name . $ext;

        $fileContent = stripos($this->file, ';base64,') ? substr(strchr($this->file, ';base64,'), strlen(';base64,')) : $this->file;
        $putRs = file_put_contents($filePath, base64_decode($fileContent));
        if ($putRs) {
            $domain = new FileDomain();
            
            $fileUrl = sprintf('/%s/%s%s', implode('/', $pathArr), $name, $ext);
            $webUrl = $domain->getHost() . $fileUrl;
            
            $ossUrl = $this->tryToUploadFileToOSS($name . $ext, $filePath);
            if ($ossUrl) {
                $webUrl = $ossUrl;
                //unlink($filePath); // 可以移除本地文件，避免冗余
            }
            
            $domain->addUploadFile($fileName, $type, filesize($filePath), $fileUrl, $webUrl);
            
            $rs['url'] = $webUrl;
        }

        return $rs;
    }
    
    /**
     * 上传文件到阿里云OSS对象存储
     * 
     * @param string $object 文件名称
     * @param string $filePath <yourLocalFile>由本地文件路径加文件名包括后缀组成，例如/users/local/myfile.txt
     * @return string|boolean 成功时返回链接，失败时返回false或空
     * @link https://www.alibabacloud.com/help/zh/doc-detail/88473.htm?spm=a2c63.p38356.879954.16.24307a1dJvnUDW
     */
    protected function tryToUploadFileToOSS($object, $filePath) {
        $aliyuOssCfg = \PhalApi\DI()->config->get('app.upload.aliyu_oss');
        
        // 阿里云主账号AccessKey拥有所有API的访问权限，风险很高。强烈建议您创建并使用RAM账号进行API访问或日常运维，请登录RAM控制台创建RAM账号。
        $accessKeyId = $aliyuOssCfg['accessKeyId'];
        $accessKeySecret = $aliyuOssCfg['accessSecret'];
        // Endpoint以杭州为例，其它Region请按实际情况填写。
        $endpoint = $aliyuOssCfg['endpoint'];
        // 设置存储空间名称。
        $bucket= $aliyuOssCfg['bucket'];
        if (empty($accessKeyId) || empty($accessKeySecret) || empty($endpoint) || empty($bucket)) {
            return false;
        }
        
        try{
            $isCName = !empty($aliyuOssCfg['isCName']) ? true : false;
            $ossClient = new OssClient($accessKeyId, $accessKeySecret, $endpoint, $isCName);
            
            // 目录前缀
            $filePath = !empty($aliyuOssCfg['filePathPrefixx']) ? $aliyuOssCfg['filePathPrefixx'] . $filePath : $filePath; 
            
            $res = $ossClient->uploadFile($bucket, $object, $filePath);
            
            return !empty($res['info']['url']) ? $res['info']['url'] : '';
        } catch(OssException $e) {
            throw $e;
            return false;
        }
    }
    
    protected function getUploadFolderPath() {
        return \PhalApi\DI()->config->get('app.upload.upload_folder_path');
    }
}
